use strict; 

print "Choose experimental folder:\nUSAGE: x:\\a\\b\\c\n(right_click -> paste)";
my $choice = <STDIN>;																		#flexible input of directory
chomp $choice;

(my $parentdir = $choice);  				                                                                                      
#print "$parentdir\n";
chdir($parentdir);
opendir(DIR1, $parentdir) or die "can't opendir $parentdir: $!";
my @listdir = readdir (DIR1);																#reads all the experiment directories

my @experiment_folders;	
my %folder_structure;
my @macros;		

open OUT, ">$parentdir/makemulti-macro.ijm" or die $!,"\n" ;	

print OUT qq(setBatchMode(true));								

foreach my $folder (@listdir){																#makes the needed destination folders within the experimental folders and pushes the experiment folders into an array
			if ($folder !~ /\.|macros|max|deconvolved|multi/ig) {
			
			#print $folder,"\n";
			mkdir("$folder/multi_tiff", 0777) || print $!;
			mkdir("$folder/multi_tiff/CO1", 0777) || print $!;
			mkdir("$folder/multi_tiff/CO2", 0777) || print $!;
			mkdir("$folder/multi_tiff/CO3", 0777) || print $!;
			mkdir("$folder/multi_tiff/CO4", 0777) || print $!;
			mkdir("$folder/multi_tiff/CO5", 0777) || print $!;
			mkdir("$folder/multi_tiff/CO6", 0777) || print $!;

			
			my $experiment = $parentdir."\\".$folder;
			push @experiment_folders, ($experiment);
			}
}	





	
foreach my $exp_folder (@experiment_folders) { 

	print "$exp_folder\n";
	
	my @tags = split (/\\/, $exp_folder);
	my $tag = $tags[-1];
	#print "$tag\n\n";
	
	my $SIdata = $exp_folder."\\SIdata";
	
	print "$SIdata\n";
	
	chdir($SIdata);
	opendir(DIR3, $SIdata) or die "can't opendir $SIdata: $!";
	my @listfiles = readdir (DIR3);
	#print "@listfiles";
	
	my %wellhash;
	my @wellarray;

	while (my $file = shift @listfiles){                              																#iterates over the filenames, splits the filenames and loads the well and rest into an hash
		my ($coord, $subpos, $loop, $color, $slice, $px, $pw, $int, $tm, $x, $y, $y, $z, $t, $well) = split ('--', $file);
		
		$wellhash{$coord."--".$subpos."--".$loop."--".$color} = "$slice" unless $file !~ /\.tif/ig;        							#is using only *.tif files
	}
	
	while ( (my $key,my $value) = each %wellhash){                                 													#makes an sorted array of the wells present in the folder (the hash was used to find unique wells, so it ignores the number of images per well
			push @wellarray, ("$key");
			#print "$key\n";
		}
		
		my @sorted_wellarray = sort @wellarray;		
		#print "@sorted_wellarray";
		
		while (my $line = shift @sorted_wellarray) {
			
			my ($coord, $subpos, $loop, $color) = split ('--', $line);
			#print "$coord, $subpos, $loop, $color\n";
			
			(my $modparent = $SIdata) =~   s/\\/\\\\/g;
			(my $moddest = $exp_folder) =~   s/\\/\\\\/g;
	
	print "Coord: $coord Subpos: $subpos Loop: $loop Color: $color\n";
	
	#print "$color\n";
	if ($color =~ /CO3/ig){
	#print "$color\n";
			print OUT qq(
				run("Image Sequence...", "open=$modparent\\\\anyimage.tif number=1000 starting=1 increment=1 scale=100 file=($coord--$subpos--$loop--$color--SL...) sort");
				saveAs("Tiff", "$moddest\\\\multi_tiff\\\\$color\\\\$coord--$subpos--$loop--MULTI--$color");
				run("Close All");
				);	
				}
		}	
		
	
}	
	
	
	

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	




